import cPickle

# bigarray = cPickle.load(open('roll_call.pik','r'))
vLUT['Yea'] = 1
vLUT['Nay'] = 0
vLUT['Not Voting'] = -1

vLUT['Not Guilty'] = 0
vLUT['Guilty'] = 1
vLUT['Present, Giving Live Pair'] = -1
vLUT['Present'] = -1

exceptions = ['Nelson','Campbell','Dole','Graham','Jeffords','Shelby','Smith'] # the senators that cannot be distinguished on the base of last names


congresses = []
for i in bigarray:
    [congress, session, voteno, date, votecode, title, votedetail, voteprop, totalyea, totalnay, totalnv, voteoutcome, vot] = i
    if not congress in congresses:
        congresses.append(congress)

def doit(checking,cong):
    senators = []
    sLUT = {}
    # update/create the senators list
    for i in bigarray:
        [congress, session, voteno, date, votecode, title, votedetail, voteprop, totalyea, totalnay, totalnv, voteoutcome, vot] = i
        if not checking or cong==congress:
            for x in vot:
                (name,vote,party,state) = x
                if not sLUT.has_key(name):
                    a = string.split(name,sep=' ')[0]
                    if not a in exceptions and sLUT.has_key(a):
                        ai = sLUT[a]
                        sLUT[name] = ai
                        if len(name) > senators[ai][0]:
                            # replace the name
                            senators[ai] = [name,party,state,date]
                    else:
                        sLUT[name] = len(senators)
                        sLUT[a] = len(senators)
                        senators.append([name,party,state,date])
    cPickle.dump(senators,open('s-%s.pik'%str(cong),'w'))
    # prepare the votes list 
    votes = []
    xvotes = []
    for i in bigarray:
        [congress, session, voteno, date, votecode, title, votedetail, voteprop, totalyea, totalnay, totalnv, voteoutcome, vot] = i
        if not checking or cong==congress:
            # process the votes:
            vote = [-2]*len(senators) # missing value...
            for x in vot:
                (name,v,party,state) = x
                idx = vLUT[v]
                vote[sLUT[name]] = idx
            votes.append(vote)
            vote_n = len(xvotes)
            xvotes.append([vote_n, date, congress, session, voteno, votecode, title, votedetail, voteprop, totalyea, totalnay, totalnv, voteoutcome])
    cPickle.dump(votes,open('v-%s.pik'%str(cong),'w'))
    cPickle.dump(xvotes,open('vote-%s.pik'%str(cong),'w'))


print congresses
for x in congresses:
    doit(1,x)
doit(0,'all')
